<template>
    <div>
        <div
            v-if="statisticsData"
        >
            <div
                class="mt-4 lg:grid lg:grid-cols-3 lg:gap-1"
            >
                <div
                    class="w-full px-4 py-2 bg-purple-700 text-white relative mb-4"
                >
                    <div
                        class="font-bold text-2xl my-2 font-mono"
                    >
                        {{ $helper.fundFormat(fundBalance) }}
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('current_balance') }}
                    </div>
                    <div
                        class="absolute inset-y-2 right-2 text-white fill-white"
                    >
                        <font-awesome-icon
                            icon="fa-solid fa-money-bill"
                            size="4x"
                            class="opacity-50"
                        />
                    </div>
                </div>
                <div
                    class="w-full px-4 py-2 bg-purple-700 text-white relative mb-4"
                >
                    <div
                        class="font-bold text-2xl my-2 font-mono"
                    >
                        {{ $helper.fundFormat(statisticsData.pending_fund_acceptance) }}
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('pending_fund_acceptance') }}
                    </div>
                    <div
                        class="absolute inset-y-2 right-2 text-white fill-white"
                    >
                        <font-awesome-icon
                            icon="fa-solid fa-money-bill"
                            size="4x"
                            class="opacity-50"
                        />
                    </div>
                </div>
                <div
                    class="w-full px-4 py-2 bg-purple-700 text-white relative mb-4"
                >
                    <div
                        class="font-bold text-2xl my-2 font-mono"
                    >
                        {{ $helper.fundFormat(statisticsData.accepted_fund) }}
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('accepted_funds') }}
                    </div>
                    <div
                        class="absolute inset-y-2 right-2 text-white fill-white"
                    >
                        <font-awesome-icon
                            icon="fa-solid fa-money-bill"
                            size="4x"
                            class="opacity-50"
                        />
                    </div>
                </div>
            </div>
            <div
                class="mt-4 lg:grid lg:grid-cols-2 lg:gap-1"
            >
                <div
                    class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                >
                    <div
                        class="font-bold text-2xl my-2 font-mono"
                    >
                        {{ $helper.fundFormat(statisticsData.early_withdrawal) }}
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('early_withdrawal') }}
                    </div>
                    <div
                        class="absolute inset-y-2 right-2 text-white fill-white"
                    >
                        <font-awesome-icon
                            icon="fa-solid fa-paper-plane"
                            size="4x"
                            class="opacity-50"
                        />
                    </div>
                </div>
                <div
                    class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                >
                    <div
                        class="font-bold text-2xl my-2 font-mono"
                    >
                        {{ $helper.fundFormat(statisticsData.matured) }}
                    </div>
                    <div
                        class="capitalize"
                    >
                        {{ $t('matured') }}
                    </div>
                    <div
                        class="absolute inset-y-2 right-2 text-white fill-white"
                    >
                        <font-awesome-icon
                            icon="fa-solid fa-paper-plane"
                            size="4x"
                            class="opacity-50"
                        />
                    </div>
                </div>
            </div>
        </div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="InvestmentTransaction"
                :hidden-filters="[
                    {name: 'f-has-investmentPlan-code', value: code}
                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('date_time'), name: 'created_at'},
                    {label: $t('description'), name: 'transaction_type_explained', column: 'transaction_type'},
                    {label: $t('status'), name: 'status_explained', column: 'status'},
                    {label: $t('amount'), name: 'amount'},
                ]"
                @loaded="onLoaded"
            >
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>{{ $helper.dateTimeFormat(record.created_at) }}</td>
                        <td>{{ record.transaction_type_explained }}</td>
                        <td>{{ record.status_explained }}</td>
                        <td>{{ $helper.fundFormat(record.amount) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import {computed, inject, ref} from "vue";
import {useRoute} from "vue-router";
import axios from "axios";
import BigNumber from "bignumber.js";

const $helper = inject('$helper');
const $route = useRoute();
const model = ref(null);
const dt = ref();
const updateRow = async () => {
    model.value = null;

    await dt.value.loadData();
};
const code = computed(() => {
    return $route.params.code || 'nothing';
});
const statisticsData = ref({});
const fundBalance = computed(() => {
    if (!statisticsData.value) return 0;

    return new BigNumber(statisticsData.value.accepted_fund)
        .plus(new BigNumber(statisticsData.value.pending_fund_acceptance))
        .plus(new BigNumber(statisticsData.value.early_withdrawal))
        .plus(new BigNumber(statisticsData.value.matured)).toNumber();
})

const loadData = async () => {
    try {
        const data = await axios.post('/investment_plan/transaction/load_statistics', {
            code: code.value
        });

        console.log(data);
        if (data.statistics) statisticsData.value = data.statistics;
    } catch (e) {
        console.log(e);
    }
};

const onLoaded = async () => {
    await loadData();
};
</script>
